require 'pathname'
require 'logger'
require 'thread'
require 'json'

require 'slog'
require 'chronic'
require 'daybreak'
require 'sinatra/base'

require_relative 'helpers'
require_relative 'metadata'


module TweetyBird

  # Web frontend for TweetyBird, backed by Sinatra.
  class App < Sinatra::Application
    include TweetyBird::Helpers


    def self.config! options
      @@logger = Slog::Logger.new
      @@db = Daybreak::DB.new options.database

      self.set :environment, options.environment
      self.set :port, options.port
      self.set :bind, options.bind
      self.set :raise_errors, options.debug?
      self.set :dump_errors, options.debug?
      self.set :show_exceptions, options.debug?
      self.set :logging, ::Logger::DEBUG if options.debug?
    end


    def self.close! ; end



    get '/' do
      content_type :text
      TweetyBird::VERSION
    end


    get '/:environment' do
    end


    post '/:environment/:key_path' do
    end


    put '/:environment/:key_path' do
    end


    patch '/:environment/:key_path' do
    end

  end
end