require 'logger'

require 'thor'

require_relative 'app'
require_relative 'metadata'


module TweetyBird
  class Main < Thor
    desc 'version', 'Show application version'
    def version
      puts VERSION
    end


    desc 'art', 'Show application art'
    def art
      w = ART.lines.map(&:length).sort.last
      w += 1 if w % 2 != 0
      puts
      puts 'Tweety Bird'.center(w)
      puts VERSION.center(w)
      puts
      puts SUMMARY.center(w)
      puts "\n\n\n"
      puts ART
      puts "\n\n\n"
    end


    desc 'server', 'Start the application Web server'
    option :port, \
      type: :numeric,
      aliases: %w[ -p ],
      desc: 'Set Sinatra port',
      default: 4567
    option :environment, \
      type: :string,
      aliases: %w[ -e ],
      desc: 'Set Sinatra environment',
      default: 'development'
    option :bind, \
      type: :string,
      aliases: %w[ -b ],
      desc: 'Set Sinatra interface',
      default: '0.0.0.0'
    option :database, \
      type: :string,
      aliases: %w[ -t ],
      desc: 'Location of application database',
      default: 'um.db'
    option :debug, \
      type: :boolean,
      aliases: %w[ -d ],
      desc: 'Enable debugging output',
      default: false
    def server
      App.config! options
      App.run!
      at_exit do
        App.close!
      end
    end

  end
end